extends Label

func seek_relative(fp: FileAccess, position: int) -> void:
	var old_pos := fp.get_position()
	var new_pos := old_pos + position
	fp.seek(new_pos)

func _ready() -> void:
	# This file has 8 bytes "foobar!\n"
	var fp := FileAccess.open("res://file.txt", FileAccess.READ)
	
	# Attempt to read more than 8 bytes, it reaches EOF
	text = "%s\n" % fp.get_buffer(10)
	
	# Expected position: 8
	# Actual position: 10
	text += "Position: %s" % fp.get_position()
	text += " [GOOD]\n" if fp.get_position() == 8 else " [BAD]\n"
	
	# Attempt to seek relative to current position
	seek_relative(fp, -5)
	
	# Expected position: 8 - 5 = 3
	# Actual position: 10 - 5 = 5
	text += "Position after seek: %s" % fp.get_position()
	text += " [GOOD]\n" if fp.get_position() == 3 else " [BAD]\n"
	
	# Expected string: "bar!\n"
	# Actual string: "ar!\n"
	text += "Read string: %s" % fp.get_line()
